#include <kbf.h>
#include <kbf/driver/lcd.h>
#include <kbf/driver/ultrasonic.h>

#include <unity.h>

using namespace kbf;

void clearOutput(driver::LCD &lcd) {
    lcd.move(0, 1);
    lcd << "                ";
    lcd.move(0, 1);
}

[[noreturn]] TEST_CASE("ultrasonic on LCD", "[kbf_demo]") {
    auto ultrasonic = driver::Ultrasonic(5, 18);
    auto lcd        = driver::LCD(32, 33, 25, 26, 27, 13);

    lcd << "distance: ";

    int lastDistance = 0x200;
    while (true) {
        int distance = ultrasonic.read();
        if (distance != lastDistance) {
            clearOutput(lcd);
            if (distance >= 0x200) {
                lcd << "idk lol";
            } else {
                lcd << distance << "cm";
            }
            lastDistance = distance;
        }
        kbf::sleep(300);
    }
}
